<script setup lang="ts">
import { onMounted, ref } from 'vue'
import { usePromotionStore } from '@/stores/promotion'
import promotionService from '@/services/promotion'
import type { Promotion } from '@/types/Promotion'
import type { Product } from '@/types/Product'

const promotionStore = usePromotionStore()
const slides = ['']
const promotions = ref<Promotion[]>([])
async function getPromotions() {
  try {
    const res = await promotionService.getPromotions()
    promotions.value = res.data.filter(
      (promotion: Promotion) => promotion.status !== false && isPromotionActive(promotion)
    )
  } catch (error) {
    console.log(error)
  }
}
const isPromotionActive = (promotion: Promotion): boolean => {
  const currentDate = new Date()
  const endDate = new Date(promotion.end)
  return currentDate <= endDate
}

onMounted(() => {
  getPromotions()
})

const randomColorOrangePalette = () => {
  const minRed = 250 // Minimum red component for an extremely light orange shade
  const maxRed = 255 // Maximum red component for an extremely light orange shade
  const minGreen = 220 // Minimum green component for an extremely light orange shade
  const maxGreen = 240 // Maximum green component for an extremely light orange shade
  const minBlue = 150 // Minimum blue component for an extremely light orange shade
  const maxBlue = 200
  const red = Math.floor(Math.random() * (maxRed - minRed) + minRed).toString(16)
  const green = Math.floor(Math.random() * (maxGreen - minGreen) + minGreen).toString(16)
  const blue = Math.floor(Math.random() * (maxBlue - minBlue) + minBlue).toString(16)

  return `#${red}${green}${blue}`
}
</script>

<template>
  <v-carousel height="400" show-arrows="hover" cycle v-if="promotions.length">
    <v-carousel-item v-for="(promotion, index) in promotions" :key="index">
      <v-sheet :color="randomColorOrangePalette()" height="100%">
        <v-container fill-height fluid height="100%">
          <v-layout class="align-center justify-center">
            <v-card class="cover-card ma-13" style="background-color: antiquewhite;">
              <!-- Your card content here -->
              <v-row class="justify-center align-center">
                <v-col class="justify-center align-center">
                  <v-img
                    :src="'http://localhost:3000/images/promotions/' + promotion.image"
                    width="500"
                    height="250"
                    class="rounded-circle"
                  ></v-img
                ></v-col>
                <v-col>
                  <v-card-title style="padding-top: 20px;font-size: larger;"
                    ><h1>{{ promotion.name }}</h1></v-card-title
                  >
                  <v-card-text style="padding-top: 20px"
                    ><h2>Condition : {{ promotion.condition }}</h2></v-card-text
                  >
                  <v-card-text
                    ><h2>
                      Products in Promotion :
                      {{ promotion.products.map((product: Product) => product.name).join(', ') }}
                    </h2></v-card-text
                  >
                  <v-card-text>
                    <h2 style="color: #64DD17">
                      Start Date : {{ promotion.start }}
                      <v-icon class="pa-0" color="black">mdi-arrow-right-bold</v-icon> End Date :{{
                        promotion.end
                      }}
                    </h2>
                  </v-card-text>
                </v-col>
              </v-row>
            </v-card>
          </v-layout>
        </v-container>
      </v-sheet>
    </v-carousel-item>
  </v-carousel>
  <v-carousel height="300" v-else :show-arrows="false" hide-delimiters>
    <v-container fill-height fluid height="100%">
      <v-sheet :color="randomColorOrangePalette()" height="100%" class="pa-1">
        <v-card class="cover-card ma-13 justify-center align-center font-weight-black" style="background-color: antiquewhite;"
          ><br><br><br><p style="font-size: 50px;text-align: center;">Promotion is not available during this time.</p></v-card
        ></v-sheet
      >
    </v-container>
  </v-carousel>
</template>

<style scoped>
.cover-card {
  width: auto;
  height: 100%;
}
.rounded-circle {
  border-radius: 100%;
  overflow: hidden;
}
</style>
